// written by hko haikog@gmail.com 

int many = 16; 
String notmany = "5";
int[] ops = new int[many];
int sat = 50;
int bri = 50;
int recH = 40;
String bg = "black";

int BbutX = 514; int BbutY = 10; int BbutW = 38; int BbutH = 28; color BbutCol = color(0); boolean BbutOver = false;
int LbutX = 561; int LbutY = 10; int LbutW = 68; int LbutH = 28; color LbutCol = color(0); boolean LbutOver = false;
int HbutX = 638; int HbutY = 10; int HbutW = 72; int HbutH = 28; color HbutCol = color(0); boolean HbutOver = false;
int SbutX = 718; int SbutY = 10; int SbutW = 72; int SbutH = 28; color SbutCol = color(0); boolean SbutOver = false;




void setup()
{
  colorMode(HSB, 360, 100, 100);
  PFont pix;
  pix = loadFont("pix.vlw");
  textFont(pix);
  noStroke();
  size(800, (many*50));
  background(0);
  for (int i=0; i< many; i=i+1){
    ops[i] = int(random(360));
  }
}


void draw() 
{  
  //header schwarz unterlegen
  fill(0);
  rect(0,0,width,50);

  interactive();
  
  //farbbalken zeichnen 
  for (int i=1; i < (many); i=i+1){
    fill(ops[i], sat, bri);
    rect(0, (i*50), width, recH);
    
    fill(360-ops[i], 100-sat, 100-bri);
    text("hue: "+ ops[i], 10, (i*50+(recH/2)+6));
  };

  //buttons zeichnen
  stroke(0, 0, 100); strokeWeight(2);
  fill(BbutCol); rect(BbutX, BbutY, BbutW, BbutH);
  fill(LbutCol); rect(LbutX, LbutY, LbutW, LbutH);
  fill(HbutCol); rect(HbutX, HbutY, HbutW, HbutH);
  fill(SbutCol); rect(SbutX, SbutY, SbutW, SbutH);
  noStroke();

  //beschriftungen
  fill(360, 0, 100);
  text("saturation: " + sat + "%", 10, 30);
  text("brightness: " + bri + "%", 260, 30);
  text(notmany, (BbutX+7), (BbutY+20));
  text("line", (LbutX+7), (LbutY+20));
  text("hues", (HbutX+7), (HbutY+20));  
  text("save", (SbutX+7), (SbutY+20));
}


void interactive()
{
  //BarCountbutton?
  if (mouseX >= BbutX && mouseX <= (BbutX+BbutW) && mouseY >= BbutY && mouseY <= (BbutY+BbutH))
       { BbutCol = color(100); BbutOver = true; }
  else { BbutCol = color(0); BbutOver = false; }
  
  //Linesbutton?
  if (mouseX >= LbutX && mouseX <= (LbutX+LbutW) && mouseY >= LbutY && mouseY <= (LbutY+LbutH))
       { LbutCol = color(100); LbutOver = true; }
  else { LbutCol = color(0); LbutOver = false; }
  
  //HueRandomizerbutton?
  if (mouseX >= HbutX && mouseX <= (HbutX+HbutW) && mouseY >= HbutY && mouseY <= (HbutY+HbutH))
       { HbutCol = color(100); HbutOver = true; }
  else { HbutCol = color(0); HbutOver = false; }
  
  //Saverbutton?
  if (mouseX >= SbutX && mouseX <= (SbutX+SbutW) && mouseY >= SbutY && mouseY <= (SbutY+SbutH))
       { SbutCol = color(100); SbutOver = true; }
  else { SbutCol = color(0); SbutOver = false; }

  //Do stuff continously
  if (mousePressed)
  {
    if (HbutOver)
    {
      for (int i=0; i< many; i=i+1){ 
        ops[i] = int(random(360));
      }
    } 
    else if (SbutOver == false && LbutOver == false && BbutOver == false && HbutOver == false)
    {
      sat = mouseY/((many*50)/100);
      bri = mouseX/(width/100);
    }
  }
}


//do stuff once
void mousePressed ()
{
  if (SbutOver)
  {
    saveFrame ("randomcolour_##.png");
  }
  else if (LbutOver)
  {
    if (recH == 40 && bg == "black"){bg = "white"; fill(360); rect(0, 50, width, height);}
    else if (recH == 40 && bg == "white") {recH = 50;}
    else { recH = 40; bg = "black"; fill(0); rect(0, 50, width, height);} 
  }
  else if (BbutOver)
  {
    if (many == 16){ many = 6; notmany = "15"; frame.setSize(800, (many*50+20));}
    else { many = 16; notmany = "5"; frame.setSize(800, (many*50+20));}
  }
}
